
// Ce code a pour but de tester un moteur en Boucle ouverte

#include <SimpleTimer.h>

SimpleTimer timer;                 // Timer pour échantillonnage

const int frequence_echantillonnage = 50;  // Fréquence d'exécution de l'asservissement
const int duree=2000; // Durée de l'essai en ms
const int frequence_sinus=1; // Fréquence de l'essai harmonique
const float pi=3.1416;

unsigned int tick_codeuse = 0;     // Compteur de tick de la codeuse
int vitMoteur = 0;                       // Commande du moteur
int rapport_reducteur = 34;          // Rapport entre le nombre de tours de l'arbre moteur et de la roue
int resolution = 24;  
unsigned int time = 0;
long debut=0;

//definition des entrées

const int vitesseMotB=6; // PWM 11 (Arduino Shield) ou 6 (DFRobot Shield)
const int sensMotB=7; // Sens 13 (Arduino Shield) ou 7 (DFRobot Shield)

/* ==================================================================
 *  ROUTINE D'INITIALISATION
 * ==================================================================
 */
 void setup() {
  Serial.begin(9600);         // Initialisation port COM
  pinMode (vitesseMotB,OUTPUT); // Broche vitesseMotA configurée en sortie
  pinMode (sensMotB,OUTPUT); // Broche freinMotA configurée en sortie

  digitalWrite(vitesseMotB,LOW); // Moteur à l'arret
  digitalWrite(sensMotB,LOW); // Sens moteur
  
  attachInterrupt(0, compteur, CHANGE);    // Interruption sur tick de la codeuse  (interruption 0 = pin2 arduino)
  timer.setInterval(1000/frequence_echantillonnage, asservissement);  // Interruption pour calcul du PID et asservissement; toutes les 10ms, on recommence la routine

  debut=millis();
}


/* ==================================================================
 *  FONCTION PRINCIPALE
 * ==================================================================
 */
void loop(){
if ((millis()-debut)<duree) { // Tant que la durée est inférieure à la durée prévue de l''ssai
  timer.run();  //on fait tourner l'horloge

  vitMoteur=(float)70*2.55; // Consigne fixe en % (rapport cyclique)
//  vitMoteur=(double)analogRead(2)/4; // Lecture analogique de la consigne
//  vitMoteur=200/2*(1+sin((float)2*pi*frequence_sinus*(millis()-debut)/1000));
  
    // Commande de la rotation du moteur
    if (vitMoteur >= 0) {
      digitalWrite( sensMotB, LOW );
      analogWrite( vitesseMotB, vitMoteur );
    }  
  }
  else {
    analogWrite( vitesseMotB, 0 );
    Serial.print("Fin/");
    Serial.print(vitMoteur/2.55);Serial.print("|");
    Serial.end();
  }
}

/* ==================================================================
 *  ROUTINE D'INCREMENT DU COMPTEUR CODEUR
 *  Interruption sur tick de la codeuse
 * ==================================================================
 */
void compteur(){
  tick_codeuse++; 
  // On incrémente le nombre de tick de la codeuse.   un seul sens
}


/* ==================================================================
 *  ROUTINE DE CALCUL DE LA VITESSE
 * ==================================================================
 */
void asservissement()
{
  Serial.print(millis());Serial.print("/");
  // Calcul de la vitesse
  int frequence_codeuse = frequence_echantillonnage*tick_codeuse; //100*tick_codeuse
  float vit_roue_tour_sec = (float)frequence_codeuse/(float)resolution/(float)rapport_reducteur; 
  
  // Réinitialisation du nombre de tick de la codeuse
  tick_codeuse=0;



  Serial.print(vitMoteur);Serial.print("/");
  Serial.print(vit_roue_tour_sec);Serial.println("|");  
}

